// プッシュ通知を受け取ったときのイベント
self.addEventListener('push', (e) => {
    const title = 'Push通知テスト';
    const options = {
        body: e.data.text(), // サーバーからのメッセージ
        tag: title, // タイトル
        icon: 'icon-512x512.png', // アイコン
        badge: 'icon-512x512.png' // アイコン
    };

    e.waitUntil(self.registration.showNotification(title, options));
    Notify(e.data.text());
});

self.addEventListener('error', (e) => {
    console.log(e)
    Notify('エラーが発生しました');
}, false);

// プッシュ通知をクリックしたときのイベント
self.addEventListener('notificationclick', (e) => {
    e.notification.close();
    e.waitUntil(clients.openWindow('http://localhost:8080/'));
});

// Service Worker インストール時に実行される
// キャッシュするファイルとかをここで登録する
self.addEventListener('install', (e) => {
    console.log('service worker install ...');
    // e.waitUntil(self.skipWaiting());
});

self.addEventListener('message', (e) => {
    throw new Error('エラーが発生しました。');
    Notify(e.data);
})

function Notify(data) {
    self.clients.claim();
    self.clients.matchAll().then(all => all.forEach(client => {
        client.postMessage(data);
    }));
}